<template>
  <div class="py-24">
    <!-- Titre page -->
    <h1 class="mx-auto mb-10 w-max text-3xl">Inscription</h1>
    <!-- Formulaire inscription -->
    <form @submit="registration" class="p-8 m-auto w-min bg-gray-200 rounded">
      <div class="flex">
        <div>
          <!-- Formulaire > name -->
          <p class="py-2 text-xl">Prénom</p>
          <label>
            <input v-model="name" type="text" required min="6" placeholder="bienvenue" class="p-1 border-2 border-gray-400 rounded">
          </label>
        </div>
        <!-- Formulaire > photo de profil // WORK IN PROGRESS -->
        <div class="ml-20 w-28 h-28 border-2 border-gray-400 rounded-full bg-white">
          <div v-if="1 < 0" class="flex justify-center items-center w-28 h-28 text-center">
            <!-- Prévisualisation photo profil -->
            <!-- To do : créer l'image -->
          </div>
          <!-- Si pas de photo profil a prévisualisé invite le user a séléctionner une image -->
          <div v-else class="flex justify-center items-center w-28 h-28 text-center">
            <p class="text-gray-300">Photo de profil</p>
          </div>
          <!-- Photo de profil input caché -->
          <label>
            <input ref="profilPictureInput" accept="image/*" type="file" class="hidden">
          </label>
        </div>
      </div>
      <!-- Formulaire > email -->
      <div class="mt-4">
        <p class="py-2 text-xl">Adresse email</p>
        <label>
          <input v-model="email" type="email" required min="6" placeholder="votre adresse email" class="p-1 w-full border-2 border-gray-400 rounded">
        </label>
      </div>
      <!-- Formulaire > mot de passe et confirmation -->
      <div class="flex mt-5">
        <div class="mr-4">
          <p class="py-2 text-xl">Mot de passe</p>
          <label>
            <input v-model="password" type="password" required min="6" placeholder="mot de passe" class="p-1 border-2 border-gray-400 rounded">
          </label>
          <p class="mt-2 text-xs">Minimum 6 caractères</p>
        </div>
        <div>
          <p class="py-2 text-xl">Confirmer</p>
          <label>
            <input v-model="confirmPassword" type="password" required placeholder="mot de passe" class="p-1 border-2 border-gray-400 rounded">
          </label>
        </div>
      </div>
      <!-- Formulaire > bouton -->
      <input type="submit" value="S'inscrire" class="cursor-pointer px-2 py-1.5 mt-8 bg-white border-2 border-yellow-600 rounded transition-all hover:text-white hover:bg-yellow-600">
    </form>
    <!-- Formulaire > erreur -->
    <div v-if="error" class="m-auto mt-5 w-3/4 text-center text-red-600">
      <p>{{ error }}</p>
    </div>
  </div>
</template>

<script>
import firebase from 'firebase'
import { db } from '@/main'
export default {
  name: 'Register',
  data: () => ({
    name: '',
    email: '',
    password: '',
    confirmPassword: '',
    error: null
  }),
  methods: {
    // Fctn pour s'inscrire
    async registration() {
      if (this.password === this.confirmPassword) {
        try {
          const currentUser = await firebase.auth().createUserWithEmailAndPassword(this.email, this.password)
          await db.collection('users').add({
            id: currentUser.user.uid,
            email: this.email,
            name: this.name,
            createdAt: new Date()
          })
          console.log('Registration : user signin success') // TO CLEAN
        }
        catch (err) {
          console.log('Registration : user signin error') // TO CLEAN
          this.error = err
          console.log(`Auth error: ${err}`)
        }
      }
      else {
        this.error = 'Password doesn\'t match'
      }
    }
  }
}
</script>
